#!/bin/bash

export Script_Dir="${0%/*}"
export Service_Name="ChronicallServer"
export Service_Display_Name="Chronicall Server"
export Pid="ChronicallServerPid"
export Temp_Pid="TempChronicallServerPid"
export Test_Filename="ChronicallServerProcessAliveTest.txt"

#Shutdown
echo Attempting to stop "$Service_Display_Name"
#If pid file exists and isn't empty
if [ -s "$Script_Dir"/"$Pid" ]
then
	#Save process info
	ps aux | grep -v grep | grep `cat "$Script_Dir"/"$Pid"` > "$Script_Dir"/"$Test_Filename"
	#If process info exists
	if [ -s "$Script_Dir"/"$Test_Filename" ]
	then
		echo Stopping "$Service_Display_Name" \(pid `cat "$Script_Dir"/"$Pid"`\)
		cat "$Script_Dir"/"$Pid" > "$Script_Dir"/"$Temp_Pid"
	else
		echo "$Service_Display_Name" is not running
	fi
	rm "$Script_Dir"/"$Pid"
	rm "$Script_Dir"/"$Test_Filename"
else
	echo "$Service_Display_Name" is not running
fi

#Startup
#If pid file exists and isn't empty
if [ -s "$Script_Dir"/"$Pid" ]
then
	#Save process info
	ps aux | grep -v grep | grep `cat "$Script_Dir"/"$Pid"` > "$Script_Dir"/"$Test_Filename"
	#If process info exists
	if [ -s "$Script_Dir"/"$Test_Filename" ]
	then
		rm "$Script_Dir"/"$Test_Filename"
		echo "$Service_Display_Name" is already running
	else
		echo Starting "$Service_Display_Name"
		rm "$Script_Dir"/"$Test_Filename"
		ulimit -n 30000
		nohup "$Script_Dir"/"$Service_Name" start > /dev/null 2>&1&
		echo "$!" > "$Script_Dir"/"$Pid"
	fi
else
	echo Starting "$Service_Display_Name"
	ulimit -n 30000
	nohup "$Script_Dir"/"$Service_Name" start > /dev/null 2>&1&
	echo "$!" > "$Script_Dir"/"$Pid"
fi

#Have to kill the old process after the first for some reason?
if [ -s "$Script_Dir"/"$Temp_Pid" ]
then
	kill -9 `cat "$Script_Dir"/"$Temp_Pid"`
	rm "$Script_Dir"/"$Temp_Pid"
fi